FLTK 1.3.2

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions
Fl_Browser Class Reference

The Fl_Browser widget displays a scrolling list of text lines, and manages all the storage for the text. More...

`#include <Fl_Browser.H>`

Inheritance diagram for Fl_Browser:

List of all members.

## Public Types
enum | Fl_Line_Position { TOP, BOTTOM, MIDDLE }
| For internal use only?
## Public Member Functions
void | add (const char *newtext, void *d=0)
| Adds a new line to the end of the browser.
void | bottomline (int line)
| Scrolls the browser so the bottom item in the browser is showing the specified `line`.
void | clear ()
| Removes all the lines in the browser.
char | column_char () const
| Gets the current column separator character.
void | column_char (char c)
| Sets the column separator to c.
const int * | column_widths () const
| Gets the current column width array.
void | column_widths (const int *arr)
| Sets the current array to `arr`.
void * | data (int line) const
| Returns the user data() for specified `line`.
void | data (int line, void *d)
| Sets the user data for specified `line` to `d`.
void | display (int line, int val=1)
| For back compatibility.
int | displayed (int line) const
| Returns non-zero if `line` has been scrolled to a position where it is being displayed.
| Fl_Browser (int X, int Y, int W, int H, const char *L=0)
| The constructor makes an empty browser.
char | format_char () const
| Gets the current format code prefix character, which by default is '@'.
void | format_char (char c)
| Sets the current format code prefix character to `c`.
void | hide (int line)
| Makes `line` invisible, preventing selection by the user.
void | hide ()
| Hides the entire Fl_Browser widget -- opposite of show().
void | icon (int line, Fl_Image *icon)
| Set the image icon for `line` to the value `icon`.
Fl_Image * | icon (int line) const
| Returns the icon currently defined for `line`.
void | insert (int line, const char *newtext, void *d=0)
| Insert a new entry whose label is `newtext` above given `line`, optional data `d`.
void | lineposition (int line, Fl_Line_Position pos)
| Updates the browser so that `line` is shown at position `pos`.
int | load (const char *filename)
| Clears the browser and reads the file, adding each line from the file to the browser.
void | make_visible (int line)
| Make the item at the specified `line` visible().
void | middleline (int line)
| Scrolls the browser so the middle item in the browser is showing the specified `line`.
void | move (int to, int from)
| Line `from` is removed and reinserted at `to`.
void | remove (int line)
| Remove entry for given `line` number, making the browser one line shorter.
void | remove_icon (int line)
| Removes the icon for `line`.
void | replace (int a, const char *b)
| For back compatibility only.
int | select (int line, int val=1)
| Sets the selection state of the item at `line` to the value `val`.
int | selected (int line) const
| Returns 1 if specified `line` is selected, 0 if not.
void | show (int line)
| Makes `line` visible, and available for selection by user.
void | show ()
| Shows the entire Fl_Browser widget -- opposite of hide().
int | size () const
| Returns how many lines are in the browser.
void | size (int W, int H)
| Changes the size of the widget.
void | swap (int a, int b)
| Swaps two browser lines `a` and `b`.
const char * | text (int line) const
| Returns the label text for the specified `line`.
void | text (int line, const char *newtext)
| Sets the text for the specified `line` to `newtext`.
int | topline () const
| Returns the line that is currently visible at the top of the browser.
void | topline (int line)
| Scrolls the browser so the top item in the browser is showing the specified `line`.
int | value () const
| Returns the line number of the currently selected line, or 0 if none.
void | value (int line)
| Sets the browser's value(), which selects the specified `line`.
int | visible (int line) const
| Returns non-zero if the specified `line` is visible, 0 if hidden.
| ~Fl_Browser ()
| The destructor deletes all list items and destroys the browser.
## Protected Member Functions
FL_BLINE * | _remove (int line)
| Removes the item at the specified `line`.
FL_BLINE * | find_line (int line) const
| Returns the item for specified `line`.
int | full_height () const
| The height of the entire list of all visible() items in pixels.
int | incr_height () const
| The default 'average' item height (including inter-item spacing) in pixels.
void | insert (int line, FL_BLINE *item)
| Insert specified `item` above `line`.
void * | item_at (int line) const
| Return the item at specified `line`.
void | item_draw (void *item, int X, int Y, int W, int H) const
| Draws `item` at the position specified by `X` `Y` `W` `H`.
void * | item_first () const
| Returns the very first item in the list.
int | item_height (void *item) const
| Returns height of `item` in pixels.
void * | item_last () const
| Returns the very last item in the list.
void * | item_next (void *item) const
| Returns the next item after `item`.
void * | item_prev (void *item) const
| Returns the previous item before `item`.
void | item_select (void *item, int val)
| Change the selection state of `item` to the value `val`.
int | item_selected (void *item) const
| See if `item` is selected.
void | item_swap (void *a, void *b)
| Swap the items `a` and `b`.
const char * | item_text (void *item) const
| Returns the label text for `item`.
int | item_width (void *item) const
| Returns width of `item` in pixels.
int | lineno (void *item) const
| Returns line number corresponding to `item`, or zero if not found.
void | swap (FL_BLINE *a, FL_BLINE *b)
| Swap the two items `a` and `b`.

## Detailed Description

The Fl_Browser widget displays a scrolling list of text lines, and manages all the storage for the text.

This is not a text editor or spreadsheet! But it is useful for showing a vertical list of named objects to the user.

Each line in the browser is identified by number. The numbers start at one (this is so that zero can be reserved for "no line" in the selective browsers). Unless otherwise noted, the methods do not check to see if the passed line number is in range and legal. It must always be greater than zero and <= size().

Each line contains a null-terminated string of text and a void * data pointer. The text string is displayed, the void * pointer can be used by the callbacks to reference the object the text describes.

The base class does nothing when the user clicks on it. The subclasses Fl_Select_Browser, Fl_Hold_Browser, and Fl_Multi_Browser react to user clicks to select lines in the browser and do callbacks.

The base class Fl_Browser_ provides the scrolling and selection mechanisms of this and all the subclasses, but the dimensions and appearance of each item are determined by the subclass. You can use Fl_Browser_ to display information other than text, or text that is dynamically produced from your own data structures. If you find that loading the browser is a lot of work or is inefficient, you may want to make a subclass of Fl_Browser_.

Some common coding patterns used for working with Fl_Browser:

          // How to loop through all the items in the browser
          for ( int t=1; t<=browser->size(); t++ ) {       // index 1 based..!
              printf("item #%d, label='%s'\n", t, browser->text(t));
          }

Note: If you are subclassing Fl_Browser, it's more efficient to use the protected methods item_first() and item_next(), since Fl_Browser internally uses linked lists to manage the browser's items. For more info, see find_item(int).

## Constructor & Destructor Documentation

Fl_Browser::Fl_Browser | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | L = `0`
| ) |  |

The constructor makes an empty browser.

Parameters:

  [in] | X,Y,W,H | position and size.
  [in] | L | label string, may be NULL.

## Member Function Documentation

FL_BLINE * Fl_Browser::_remove | ( | int | line | ) | `[protected]`

Removes the item at the specified `line`.

Caveat: See efficiency note in find_line(). You must call redraw() to make any changes visible.

Parameters:

  [in] | line | The line number to be removed. (1 based) Must be in range!

Returns:
  Pointer to browser item that was removed (and is no longer valid).

See also:
  add(), insert(), remove(), swap(int,int), clear()

void Fl_Browser::add | ( | const char * | newtext,
|  | void * | d = `0`
| ) |  |

Adds a new line to the end of the browser.

The text string `newtext` may contain format characters; see format_char() for details. `newtext` is copied using the strdup() function, and can be NULL to make a blank line.

The optional void* argument `d` will be the data() for the new item.

Parameters:

  [in] | newtext | The label text used for the added item
  [in] | d | Optional user data() for the item (0 if unspecified)

See also:
  add(), insert(), remove(), swap(int,int), clear()

void Fl_Browser::bottomline | ( | int | line | ) | `[inline]`

Scrolls the browser so the bottom item in the browser is showing the specified `line`.

Parameters:

  [in] | line | The line to be displayed at the bottom.

See also:
  topline(), middleline(), bottomline(), displayed(), lineposition()

void Fl_Browser::clear | ( |  | ) |

Removes all the lines in the browser.

See also:
  add(), insert(), remove(), swap(int,int), clear()

Reimplemented from Fl_Group.

char Fl_Browser::column_char | ( |  | ) | const`[inline]`

Gets the current column separator character.

The default is '\t' (tab).

See also:
  column_char(), column_widths()

void Fl_Browser::column_char | ( | char | c | ) | `[inline]`

Sets the column separator to c.

This will only have an effect if you also set column_widths(). The default is '\t' (tab).

See also:
  column_char(), column_widths()

const int* Fl_Browser::column_widths | ( |  | ) | const`[inline]`

Gets the current column width array.

This array is zero-terminated and specifies the widths in pixels of each column. The text is split at each column_char() and each part is formatted into it's own column. After the last column any remaining text is formatted into the space between the last column and the right edge of the browser, even if the text contains instances of column_char() . The default value is a one-element array of just a zero, which means there are no columns.

Example:

      Fl_Browser *b = new Fl_Browser(..);
      static int widths[] = { 50, 50, 50, 70, 70, 40, 40, 70, 70, 50, 0 };  // widths for each column
      b->column_widths(widths); // assign array to widget
      b->column_char('\t');     // use tab as the column character
      b->add("USER\tPID\tCPU\tMEM\tVSZ\tRSS\tTTY\tSTAT\tSTART\tTIME\tCOMMAND");
      b->add("root\t2888\t0.0\t0.0\t1352\t0\ttty3\tSW\tAug15\t0:00\t@b@f/sbin/mingetty tty3");
      b->add("root\t13115\t0.0\t0.0\t1352\t0\ttty2\tSW\tAug30\t0:00\t@b@f/sbin/mingetty tty2");
      [..]

See also:
  column_char(), column_widths()

void Fl_Browser::column_widths | ( | const int * | arr | ) | `[inline]`

Sets the current array to `arr`.

Make sure the last entry is zero.

See also:
  column_char(), column_widths()

void * Fl_Browser::data | ( | int | line | ) | const

Returns the user data() for specified `line`.

Return value can be NULL if `line` is out of range or no user data() was defined. The parameter `line` is 1 based (1 will be the first item in the list).

Parameters:

  [in] | line | The line number of the item whose data() is returned. (1 based)

Returns:
  The user data pointer (can be NULL)

void Fl_Browser::data | ( | int | line,
|  | void * | d
| ) |  |

Sets the user data for specified `line` to `d`.

Does nothing if `line` is out of range.

Parameters:

  [in] | line | The line of the item whose data() is to be changed. (1 based)
  [in] | d | The new data to be assigned to the item. (can be NULL)

void Fl_Browser::display | ( | int | line,
|  | int | val = `1`
| ) |  |

For back compatibility.

This calls show(line) if `val` is true, and hide(line) otherwise. If `val` is not specified, the default is 1 (makes the line visible).

See also:
  show(int), hide(int), display(), visible(), make_visible()

int Fl_Browser::displayed | ( | int | line | ) | const`[inline]`

Returns non-zero if `line` has been scrolled to a position where it is being displayed.

Checks to see if the item's vertical position is within the top and bottom edges of the display window. This does NOT take into account the hide()/show() status of the widget or item.

Parameters:

  [in] | line | The line to be checked

Returns:
  1 if visible, 0 if not visible.

See also:
  topline(), middleline(), bottomline(), displayed(), lineposition()

FL_BLINE * Fl_Browser::find_line | ( | int | line | ) | const`[protected]`

Returns the item for specified `line`.

Note: This call is slow. It's fine for e.g. responding to user clicks, but slow if called often, such as in a tight sorting loop. Finding an item 'by line' involves a linear lookup on the internal linked list. The performance hit can be significant if the browser's contents is large, and the method is called often (e.g. during a sort). If you're writing a subclass, use the protected methods item_first(), item_next(), etc. to access the internal linked list more efficiently.

Parameters:

  [in] | line | The line number of the item to return. (1 based)

Return values:

  item | that was found.
  NULL | if line is out of range.

See also:
  item_at(), find_line(), lineno()

char Fl_Browser::format_char | ( |  | ) | const`[inline]`

Gets the current format code prefix character, which by default is '@'.

A string of formatting codes at the start of each column are stripped off and used to modify how the rest of the line is printed:

- `'@.'` Print rest of line, don't look for more '@' signs
- `'@@'` Print rest of line starting with '@'
- `'@l'` Use a LARGE (24 point) font
- `'@m'` Use a medium large (18 point) font
- `'@s'` Use a small (11 point) font
- `'@b'` Use a bold font (adds FL_BOLD to font)
- `'@i'` Use an italic font (adds FL_ITALIC to font)
- `'@f' or '@t'` Use a fixed-pitch font (sets font to FL_COURIER)
- `'@c'` Center the line horizontally
- `'@r'` Right-justify the text
- `'@B0', '@B1', ... '@B255'` Fill the backgound with fl_color(n)
- `'@C0', '@C1', ... '@C255'` Use fl_color(n) to draw the text
- `'@F0', '@F1', ...` Use fl_font(n) to draw the text
- `'@S1', '@S2', ...` Use point size n to draw the text
- `'@u' or '@_'` Underline the text.
- `'@-'` draw an engraved line through the middle.

Notice that the '@.' command can be used to reliably terminate the parsing. To print a random string in a random color, use `sprintf("@C%d@.%s", color, string)` and it will work even if the string starts with a digit or has the format character in it.

void Fl_Browser::format_char | ( | char | c | ) | `[inline]`

Sets the current format code prefix character to `c`.

The default prefix is '@'. Set the prefix to 0 to disable formatting.

See also:
  format_char() for list of '@' codes

int Fl_Browser::full_height | ( |  | ) | const`[protected, virtual]`

The height of the entire list of all visible() items in pixels.

This returns the accumulated height of *all* the items in the browser that are not hidden with hide(), including items scrolled off screen.

Returns:
  The accumulated size of all the visible items in pixels.

See also:
  item_height(), item_width(),
  incr_height(), full_height()

Reimplemented from Fl_Browser_.

void Fl_Browser::hide | ( | int | line | ) |

Makes `line` invisible, preventing selection by the user.

The line can still be selected under program control. This changes the full_height() if the state was changed. When a line is made invisible, lines below it are moved up in the display. redraw() is called automatically if a change occurred.

Parameters:

  [in] | line | The line to be hidden. (1 based)

See also:
  show(int), hide(int), display(), visible(), make_visible()

void Fl_Browser::hide | ( |  | ) | `[inline, virtual]`

Hides the entire Fl_Browser widget -- opposite of show().

Reimplemented from Fl_Widget.

void Fl_Browser::icon | ( | int | line,
|  | Fl_Image * | icon
| ) |  |

Set the image icon for `line` to the value `icon`.

Caller is responsible for keeping the icon allocated. The `line` is automatically redrawn.

Parameters:

  [in] | line | The line to be modified. If out of range, nothing is done.
  [in] | icon | The image icon to be assigned to the `line`. If NULL, any previous icon is removed.

Fl_Image * Fl_Browser::icon | ( | int | line | ) | const

Returns the icon currently defined for `line`.

If no icon is defined, NULL is returned.

Parameters:

  [in] | line | The line whose icon is returned.

Returns:
  The icon defined, or NULL if none.

int Fl_Browser::incr_height | ( |  | ) | const`[protected, virtual]`

The default 'average' item height (including inter-item spacing) in pixels.

This currently returns textsize() + 2.

Returns:
  The value in pixels.

See also:
  item_height(), item_width(),
  incr_height(), full_height()

Reimplemented from Fl_Browser_.

void Fl_Browser::insert | ( | int | line,
|  | FL_BLINE * | item
| ) |  | `[protected]`

Insert specified `item` above `line`.

If `line` > size() then the line is added to the end.

Caveat: See efficiency note in find_line().

Parameters:

  [in] | line | The new line will be inserted above this line (1 based).
  [in] | item | The item to be added.

void Fl_Browser::insert | ( | int | line,
|  | const char * | newtext,
|  | void * | d = `0`
| ) |  |

Insert a new entry whose label is `newtext` above given `line`, optional data `d`.

Text may contain format characters; see format_char() for details. `newtext` is copied using the strdup() function, and can be NULL to make a blank line.

The optional void * argument `d` will be the data() of the new item.

Parameters:

  [in] | line | Line position for insert. (1 based) If `line` > size(), the entry will be added at the end.
  [in] | newtext | The label text for the new line.
  [in] | d | Optional pointer to user data to be associated with the new line.

void* Fl_Browser::item_at | ( | int | line | ) | const`[inline, protected, virtual]`

Return the item at specified `line`.

Parameters:

  [in] | line | The line of the item to return. (1 based)

Returns:
  The item, or NULL if line out of range.

See also:
  item_at(), find_line(), lineno()

Reimplemented from Fl_Browser_.

void Fl_Browser::item_draw | ( | void * | item,
|  | int | X,
|  | int | Y,
|  | int | W,
|  | int | H
| ) |  | const`[protected, virtual]`

Draws `item` at the position specified by `X` `Y` `W` `H`.

The `W` and `H` values are used for clipping. Should only be called within the context of an FLTK draw().

Parameters:

  [in] | item | The item to be drawn
  [in] | X,Y,W,H | position and size.

Implements Fl_Browser_.

void * Fl_Browser::item_first | ( |  | ) | const`[protected, virtual]`

Returns the very first item in the list.

Example of use:

      // Walk the browser from beginning to end
      for ( void *i=item_first(); i; i=item_next(i) ) {
          printf("item label='%s'\n", item_text(i));
      }

Returns:
  The first item, or NULL if list is empty.

See also:
  item_first(), item_last(), item_next(), item_prev()

Implements Fl_Browser_.

int Fl_Browser::item_height | ( | void * | item | ) | const`[protected, virtual]`

Returns height of `item` in pixels.

This takes into account embedded @ codes within the text() label.

Parameters:

  [in] | item | The item whose height is returned.

Returns:
  The height of the item in pixels.

See also:
  item_height(), item_width(),
  incr_height(), full_height()

Implements Fl_Browser_.

void * Fl_Browser::item_last | ( |  | ) | const`[protected, virtual]`

Returns the very last item in the list.

Example of use:

      // Walk the browser in reverse, from end to start
      for ( void *i=item_last(); i; i=item_prev(i) ) {
          printf("item label='%s'\n", item_text(i));
      }

Returns:
  The last item, or NULL if list is empty.

See also:
  item_first(), item_last(), item_next(), item_prev()

Reimplemented from Fl_Browser_.

void * Fl_Browser::item_next | ( | void * | item | ) | const`[protected, virtual]`

Returns the next item after `item`.

Parameters:

  [in] | item | The 'current' item

Returns:
  The next item after `item`, or NULL if there are none after this one.

See also:
  item_first(), item_last(), item_next(), item_prev()

Implements Fl_Browser_.

void * Fl_Browser::item_prev | ( | void * | item | ) | const`[protected, virtual]`

Returns the previous item before `item`.

Parameters:

  [in] | item | The 'current' item

Returns:
  The previous item before `item`, or NULL if there none before this one.

See also:
  item_first(), item_last(), item_next(), item_prev()

Implements Fl_Browser_.

void Fl_Browser::item_select | ( | void * | item,
|  | int | val
| ) |  | `[protected, virtual]`

Change the selection state of `item` to the value `val`.

Parameters:

  [in] | item | The item to be changed.
  [in] | val | The new selection state: 1 selects, 0 de-selects.

See also:
  select(), selected(), value(), item_select(), item_selected()

Reimplemented from Fl_Browser_.

int Fl_Browser::item_selected | ( | void * | item | ) | const`[protected, virtual]`

See if `item` is selected.

Parameters:

  [in] | item | The item whose selection state is to be checked.

Returns:
  1 if selected, 0 if not.

See also:
  select(), selected(), value(), item_select(), item_selected()

Reimplemented from Fl_Browser_.

void Fl_Browser::item_swap | ( | void * | a,
|  | void * | b
| ) |  | `[inline, protected, virtual]`

Swap the items `a` and `b`.

You must call redraw() to make any changes visible.

Parameters:

  [in] | a,b | the items to be swapped.

See also:
  swap(int,int), item_swap()

Reimplemented from Fl_Browser_.

const char * Fl_Browser::item_text | ( | void * | item | ) | const`[protected, virtual]`

Returns the label text for `item`.

Parameters:

  [in] | item | The item whose label text is returned.

Returns:
  The item's text string. (Can be NULL)

Reimplemented from Fl_Browser_.

int Fl_Browser::item_width | ( | void * | item | ) | const`[protected, virtual]`

Returns width of `item` in pixels.

This takes into account embedded @ codes within the text() label.

Parameters:

  [in] | item | The item whose width is returned.

Returns:
  The width of the item in pixels.

See also:
  item_height(), item_width(),
  incr_height(), full_height()

Implements Fl_Browser_.

int Fl_Browser::lineno | ( | void * | item | ) | const`[protected]`

Returns line number corresponding to `item`, or zero if not found.

Caveat: See efficiency note in find_line().

Parameters:

  [in] | item | The item to be found

Returns:
  The line number of the item, or 0 if not found.

See also:
  item_at(), find_line(), lineno()

void Fl_Browser::lineposition | ( | int | line,
|  | Fl_Line_Position | pos
| ) |  |

Updates the browser so that `line` is shown at position `pos`.

Parameters:

  [in] | line | line number. (1 based)
  [in] | pos | position.

See also:
  topline(), middleline(), bottomline()

int Fl_Browser::load | ( | const char * | filename | ) |

Clears the browser and reads the file, adding each line from the file to the browser.

If the filename is NULL or a zero-length string then this just clears the browser. This returns zero if there was any error in opening or reading the file, in which case errno is set to the system error. The data() of each line is set to NULL.

Parameters:

  [in] | filename | The filename to load

Returns:
  1 if OK, 0 on error (errno has reason)

See also:
  add()

void Fl_Browser::make_visible | ( | int | line | ) | `[inline]`

Make the item at the specified `line` visible().

Functionally similar to show(int line). If `line` is out of range, redisplay top or bottom of list as appropriate.

Parameters:

  [in] | line | The line to be made visible.

See also:
  show(int), hide(int), display(), visible(), make_visible()

void Fl_Browser::middleline | ( | int | line | ) | `[inline]`

Scrolls the browser so the middle item in the browser is showing the specified `line`.

Parameters:

  [in] | line | The line to be displayed in the middle.

See also:
  topline(), middleline(), bottomline(), displayed(), lineposition()

void Fl_Browser::move | ( | int | to,
|  | int | from
| ) |  |

Line `from` is removed and reinserted at `to`.

Note: `to` is calculated after line `from` gets removed.

Parameters:

  [in] | to | Destination line number (calculated after line `from` is removed)
  [in] | from | Line number of item to be moved

void Fl_Browser::remove | ( | int | line | ) |

Remove entry for given `line` number, making the browser one line shorter.

You must call redraw() to make any changes visible.

Parameters:

  [in] | line | Line to be removed. (1 based) If `line` is out of range, no action is taken.

See also:
  add(), insert(), remove(), swap(int,int), clear()

Reimplemented from Fl_Group.

void Fl_Browser::remove_icon | ( | int | line | ) |

Removes the icon for `line`.

It's ok to remove an icon if none has been defined.

Parameters:

  [in] | line | The line whose icon is to be removed.

void Fl_Browser::replace | ( | int | a,
|  | const char * | b
| ) |  | `[inline]`

For back compatibility only.

int Fl_Browser::select | ( | int | line,
|  | int | val = `1`
| ) |  |

Sets the selection state of the item at `line` to the value `val`.

If `val` is not specified, the default is 1 (selects the item).

Parameters:

  [in] | line | The line number of the item to be changed. (1 based)
  [in] | val | The new selection state (1=select, 0=de-select).

Returns:
  1 if the state changed, 0 if not.

See also:
  select(), selected(), value(), item_select(), item_selected()

int Fl_Browser::selected | ( | int | line | ) | const

Returns 1 if specified `line` is selected, 0 if not.

Parameters:

  [in] | line | The line being checked (1 based)

Returns:
  1 if item selected, 0 if not.

See also:
  select(), selected(), value(), item_select(), item_selected()

void Fl_Browser::show | ( | int | line | ) |

Makes `line` visible, and available for selection by user.

Opposite of hide(int). This changes the full_height() if the state was changed. redraw() is called automatically if a change occurred.

Parameters:

  [in] | line | The line to be shown. (1 based)

See also:
  show(int), hide(int), display(), visible(), make_visible()

void Fl_Browser::show | ( |  | ) | `[inline, virtual]`

Shows the entire Fl_Browser widget -- opposite of hide().

Reimplemented from Fl_Widget.

int Fl_Browser::size | ( |  | ) | const`[inline]`

Returns how many lines are in the browser.

The last line number is equal to this. Returns 0 if browser is empty.

void Fl_Browser::size | ( | int | W,
|  | int | H
| ) |  | `[inline]`

Changes the size of the widget.

size(W, H) is a shortcut for resize(x(), y(), W, H).

Parameters:

  [in] | W,H | new size

See also:
  position(int,int), resize(int,int,int,int)

Reimplemented from Fl_Widget.

void Fl_Browser::swap | ( | FL_BLINE * | a,
|  | FL_BLINE * | b
| ) |  | `[protected]`

Swap the two items `a` and `b`.

Uses swapping() to ensure list updates correctly.

Parameters:

  [in] | a,b | The two items to be swapped.

See also:
  swap(int,int), item_swap()

void Fl_Browser::swap | ( | int | a,
|  | int | b
| ) |  |

Swaps two browser lines `a` and `b`.

You must call redraw() to make any changes visible.

Parameters:

  [in] | a,b | The two lines to be swapped. (both 1 based)

See also:
  swap(int,int), item_swap()

const char * Fl_Browser::text | ( | int | line | ) | const

Returns the label text for the specified `line`.

Return value can be NULL if `line` is out of range or unset. The parameter `line` is 1 based.

Parameters:

  [in] | line | The line number of the item whose text is returned. (1 based)

Returns:
  The text string (can be NULL)

void Fl_Browser::text | ( | int | line,
|  | const char * | newtext
| ) |  |

Sets the text for the specified `line` to `newtext`.

Text may contain format characters; see format_char() for details. `newtext` is copied using the strdup() function, and can be NULL to make a blank line.

Does nothing if `line` is out of range.

Parameters:

  [in] | line | The line of the item whose text will be changed. (1 based)
  [in] | newtext | The new string to be assigned to the item.

int Fl_Browser::topline | ( |  | ) | const

Returns the line that is currently visible at the top of the browser.

If there is no vertical scrollbar then this will always return 1.

Returns:
  The lineno() of the top() of the browser.

void Fl_Browser::topline | ( | int | line | ) | `[inline]`

Scrolls the browser so the top item in the browser is showing the specified `line`.

Parameters:

  [in] | line | The line to be displayed at the top.

See also:
  topline(), middleline(), bottomline(), displayed(), lineposition()

int Fl_Browser::value | ( |  | ) | const

Returns the line number of the currently selected line, or 0 if none.

Returns:
  The line number of current selection, or 0 if none selected.

See also:
  select(), selected(), value(), item_select(), item_selected()

void Fl_Browser::value | ( | int | line | ) | `[inline]`

Sets the browser's value(), which selects the specified `line`.

This is the same as calling select(line).

See also:
  select(), selected(), value(), item_select(), item_selected()

int Fl_Browser::visible | ( | int | line | ) | const

Returns non-zero if the specified `line` is visible, 0 if hidden.

Use show(int), hide(int), or make_visible(int) to change an item's visible state.

Parameters:

  [in] | line | The line in the browser to be tested. (1 based)

See also:
  show(int), hide(int), display(), visible(), make_visible()

The documentation for this class was generated from the following files:

- Fl_Browser.H
- Fl_Browser.cxx
- Fl_Browser_load.cxx